/*************************************************
*           BK Emulator v3.8 for Windows         *
*************************************************/

/*
File: Board_11_FDD.h
Version: 1.0.0
Written by: Yuriy Kalmykov <kalmykov@stoik.com>
    Copyright (c) 2002-2004 Yuriy Kalmykov

    BK Emulator is a program emulated hardware environment for running
code for BK 0010(01) in different configurations.

    This code may be used in compiled form in any way you desire.
This file or it's parts can't be redistributed without the authors
written consent, but can be modified for your private needs.
    Providing that this notice and the authors name and all copyright
notices remains intact.

    Please, an email me to know how you are using it and where. You can
ask me for any information about this below code or any attendant
knowledge.

    This file is provided "as is" with no expressed or implied warranty.
The author accepts no liability for any damage or loss of business that
this product may cause.
*/


// Board_11_FDD.h: interface for the CMotherBoard_11_FDD class.
// класс получился абсолютно идентичен классу  CMotherBoard_11M_FDD,
// функция в функцию, только наследуется от своего класса.


#pragma once

#include "Board_11.h"

/*
    Организация массива памяти (делается один большой массив, чтобы преобразовывать
    адрес из диапазона 64к, в зависимости от того, какие страницы подключены в окна)

    см. в файле Board_11.h, там сразу под дисковод рассчитывалось
*/

class CMotherBoard_11_FDD : public CMotherBoard_11
{
		WORD m_nFDDCatchAddr, m_nFDDExitCatchAddr;

		virtual void        OnReset();
		virtual void        ResetDevices();
		virtual bool        InitMemoryModules();
		virtual void        MemoryManager();
		virtual bool        Interception(); // Called after each command
		virtual bool        OnSetSystemRegister(WORD num, WORD src, bool bByteOperation = false);
		virtual bool        OnGetSystemRegister(WORD num, void *pDst, bool bByteOperation = false);
		virtual bool        RestoreMemory(CMSFManager &msf);

	public:
		CMotherBoard_11_FDD();
		virtual ~CMotherBoard_11_FDD();

		virtual DWORD       GetConfiguration()
		{
			return MSF_CONF_BK11_FDD;
		}
		virtual void        SetFDDType(BKFDD_MODEL model, bool bInit = true);
		virtual BYTE       *GetAddMemory(void)
		{
			return m_pMemory + 0640000;
		}
};
